%/*************************************************************************
%**  
%**  figure2.m: Plotting the empirical mean structural SDFs
%**  
%**************************************************************************/

%/* filename:  figure2.m
%** created:  12/09/06
%** modified  07/24/09
%*/

clear
clc


%/* Set the path */
pathspec; 



%/* Choose VAR lag length */
varlag = 2;

  
 
  
%/**************** Loading structural SDFs of DlnY to permanent shock: Info1 ******************/

  
  % Empirical, Non-Habit, Habit
  loadsdm = [mainpath '\spec0\info1\VAR' num2str(varlag) '\impl_spect_40_p_mean_lag2.mat'];
  load(loadsdm,'-ascii')
  sirf_y_p_var1 = impl_spect_40_p_mean_lag2(:,1);
  
 
%/**************** Loading structural SDFs of DlnY to transitory shock: Info1 ******************/

  
  % Empirical, Non-Habit, Habit
  loadsdm = [mainpath '\spec0\info1\VAR' num2str(varlag) '\impl_spect_40_t_mean_lag2.mat'];
  load(loadsdm,'-ascii')
  sirf_y_t_var1 = impl_spect_40_t_mean_lag2(:,1);
   
 
%/**************** Loading structural SDFs of DlnC to permanent shock: Info2 ******************/
  
  % Empirical, Non-Habit, Habit
  loadsdm = [mainpath '\spec0\info2\VAR' num2str(varlag) '\impl_spect_40_p_mean_lag2.mat'];
  load(loadsdm,'-ascii')
  sirf_c_p_var2 = impl_spect_40_p_mean_lag2(:,1);
  
 
%/**************** Loading structural SDFs of DlnC to transitory shock: Info2 ******************/

  
  % Empirical, Non-Habit, Habit
  loadsdm = [mainpath '\spec0\info2\VAR' num2str(varlag) '\impl_spect_40_t_mean_lag2.mat'];
  load(loadsdm,'-ascii')
  sirf_c_t_var2 = impl_spect_40_t_mean_lag2(:,1);

  
    
  
  %/************* Plotting figure 2 ******************/

  
  fig = figure(...
  'PaperType','usletter',...
  'PaperUnits','inches',...
  'PaperOrientation','landscape',...
  'PaperPosition',[-0.85 -0.5 12.5 9],...
  'PaperSize',[11 8.5]);
  

  freq = [0:0.01:3.13]';
  
  
  % Create subplot
  subplot(2,1,1,'Parent',fig,'XTickLabel',{'','8','4','2','1'},...
    'XTick',[0 20 40 80 157]);
  % Uncomment the following line to preserve the X-limits of the axes
 xlim([0 314]);
 box('on');
 hold('all');

 % Create multiple lines using matrix input to plot
  plot(sirf_y_p_var1,'LineWidth',2);
  %xlabel('Years per cycle', 'FontName','Arial')
  title('Output and consumption growth to permanent shock','FontName','Arial');
  
  
 % Create multiple lines using matrix input to plot
  plot(sirf_c_p_var2,'LineWidth',2,'LineStyle','--');
  xlabel('Years per cycle', 'FontName','Arial')
  
  legend('output growth', 'consumption growth')
  
 
  % Create subplot
  subplot(2,1,2,'Parent',fig,'XTickLabel',{'','8','4','2','1'},...
    'XTick',[0 20 40 80 157]);
  % Uncomment the following line to preserve the X-limits of the axes
 xlim([0 314]);
 box('on');
 hold('all');

 % Create multiple lines using matrix input to plot
  plot(sirf_y_t_var1,'LineWidth',2);
  xlabel('Years per cycle', 'FontName','Arial')
  title('Output and consumption growth to transitory shock','FontName','Arial');
  
  

 % Create multiple lines using matrix input to plot
  plot(sirf_c_t_var2,'LineWidth',2,'LineStyle','--');
  xlabel('Years per cycle', 'FontName','Arial')
  


  