function vvv = Fbq2(x,vcvee,bs) ;

%  *********************************************
%  * Proc to Compute Nonlinear Equations to be *
%  * Solved by the BQ decomposition, n = 2 VAR *
%  *********************************************

%  x = unknowns
%  bs(i,j) = the sum of the unrestricted vma of the
%            ith variable to the jth shock.
%  vcvee = covariance matrix of unrestriected VAR

   v1 = -vcvee(1,1) + x(1)^2 + x(2)^2 ;

   v2 = -vcvee(2,2) + x(3)^2 + x(4)^2 ;

   v3 = -vcvee(2,1) + x(1)*x(3) + x(2)*x(4) ;

   v4 = bs(1,1)*x(2) + bs(1,2)*x(4) ;

   vvv = [v1; v2; v3; v4] ;


