function xtilde = VARData(Data,lag);

%/********************************
%** Converting Data to VAR Sample 
%**   
%**  Input: Data = [y1 y2 ...]
%**         lag: lag length of the VAR
%
%    Output: xtilde = 
%       [y1(t) y2(t) ... y1(t-1) y2(t-1) ... y1(t-lag) y2(t-lag)]
%**
%*********************************/

[row,col] = size(Data);
  
  xt = Data(1+lag:row,:);
  xx = zeros(row-lag,lag*col);

 for i=1:lag;
     j=i+(col-1)*(i-1);
     xx(:,j:col*i)=Data(lag+1-i:row-i,:);
 end;

 xtilde=[xt  xx];
