function [SDF] = svmaspect(omega,simp,p);
% svmaspect: spectral density of structural impulse response
% Input: 
%     omega: frequency between 0 and pi
%     simp:  impulse response with lag length > p
%     p:     lag length taken into account
% Output: 
%     SDF: spectral density at frequency omega


if abs(imag(simp))>0
    SDF = 0;

else

spect = simp(1);
spect_comp = simp(1);

if p > 0;

  for k = 1:p;
     spect = spect + simp(k+1)*exp(complex(0,1)*k*omega);
     spect_comp = spect_comp + simp(k+1)*exp(complex(0,-1)*k*omega);
  end

end  
  
SDF = spect*spect_comp/(2*pi);





end

