%/*************************************************************************
%**  
%**  This program draws the parameters from the prior distribution
%**  
%**************************************************************************/

%/* filename:  kn_priorsim.m
%   created: 09/24/06
%*  modified: 12/19/08
%*
%*/
clear; clc;


%/* Set the path */

pathspec;


%/* Model's spec */
%   mspec = 1: NKMBC with AR money growth  
%         = 2; NKMBC with AR money growth and flexible price
%         = 3; NKMBC with AR money growth and flexible wage
%         = 4; NKMBC with Taylor rule
%         = 5; NKMBC with Taylor rule and flexible price
%         = 6: NKMBC with Taylor rule and flexible wage


mspec = 6;


%
% Number of simulation
%

ndraw = 5500;


% Load the prior 
%  only for one-sector RBC

 loadprior = [mainpath '\spec' num2str(mspec) '\habitprior.mat'];
 load(loadprior,'-ascii')
 priormat = habitprior; 
 
 

% Draw the parameters from the prior distribution
% 
 
 [npara,junk] = size(priormat);
 
  [priorsim] = kn_priordraw(priormat(:,1), priormat(:,2), priormat(:,3), priormat(:,4), priormat(:,5),ndraw);
 
    sstat = [min(priorsim)' max(priorsim)' mean(priorsim)' std(priorsim)' median(priorsim)']' ;
    ssort = sort(priorsim) ;
    %s095 = [ssort(0.025*ndraw,:)' ssort(0.975*ndraw,:)'] ;
  
  
  
  
%
% save priorsim
%
 savefile = [mainpath '\spec' num2str(mspec) '\priorsim.mat'];
 save(savefile,'priorsim','-ascii'); 
       
       
       