 %/*************************************************************************
%**  
%**  Posterior Draws of IRFs from the Posterior Distributions of VARs
%**  
%**************************************************************************/

%/* filename:  kn_sampleirf.m
%** created:  06/24/06
%** modified: 06/30/07
%             07/24/09
%*/


clear;
clc;

pathspec;

%/* Main path 
 mainpath = [mainpath '\spec0'];      
 
%/* Model's spec */
 mspec = 0;



   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Information sets
   % infospec 
   %           = 1: [DlnY DlnP]
   %           = 2: [DlnC DlnP]
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           
   infospec = 1;       
   varlag = 2;
           
           if infospec == 1;
                lags = varlag;
           elseif infospec == 2;
                lags = varlag;
           end;
           
 
%/************************************************
%**    IRFs
%**
%*************************************************/
 
 loadbvar = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\bvar.mat'];
 load(loadbvar,'-ascii') % load paraest
 
 [ndraw,npara] = size(bvar);
 
 nobs = 196;
 
 
%/* Number of draws */

horizon =41;

IMPL11=zeros(horizon,ndraw);
IMPL12=zeros(horizon,ndraw);
IMPL11g=zeros(horizon,ndraw);
IMPL12g=zeros(horizon,ndraw);
IMPL21=zeros(horizon,ndraw);
IMPL22=zeros(horizon,ndraw);
ACIMPL11=zeros(horizon,ndraw);
ACIMPL12=zeros(horizon,ndraw);

IMPL_SPECT_40_p = zeros(314,ndraw);
IMPL_SPECT_12_p = zeros(314,ndraw);
IMPL_SPECT_20_p = zeros(314,ndraw);

IMPL_SPECT_40_t = zeros(314,ndraw);
IMPL_SPECT_12_t = zeros(314,ndraw);
IMPL_SPECT_20_t = zeros(314,ndraw);

IMPL_SPECT_INF_40_p = zeros(314,ndraw);

IMPL_SPECT_INF_40_t = zeros(314,ndraw);



%/* Start drawing */

valid = 0;

for i=1:ndraw;

    
  %clc; 
  disp(sprintf('draw:   %10.3f', i));


 beta_draw = bvar(i,1:4*lags+2);
 hhh_draw = bvar(i,4*lags+2+1:npara);
 
 beta_mat = reshape(beta_draw',2*lags+1,2);
 beta_mat = beta_mat(1:2*lags,:);
 vcov_mat = inv([hhh_draw(1,1:2);hhh_draw(1,3:4)]);
 
 
  
   CMat = [beta_mat';
           eye(2*(lags-1))  zeros(2*(lags-1),2)];
      
   eigval = abs(real(eig(CMat)));
 
 
 if (max(eigval) >= 1) ;
    valid = valid + 1
      
 else;
    % BQ long-run decomposition code by Jim: revised 08/02/06 
    [c00, smimp1, smimp2, smimpl1, smimpl2] ...
                           = bqdecomp(beta_mat, vcov_mat, eye(2),lags,nobs);  
      IMPL11(:,i)=smimpl1(1:horizon,1)'; % Accumulated IRF of lnY or lnC to a permanent shock
      IMPL12(:,i)=smimpl1(1:horizon,2)'; % Accumulated IRF of lnY or lnC to a transitory shock
      IMPL11g(:,i)=smimp1(1:horizon,1)';
      IMPL12g(:,i)=smimp1(1:horizon,2)';
      IMPL21(:,i)=smimp2(1:horizon,1)';
      IMPL22(:,i)=smimp2(1:horizon,2)'; 
      
   
      % Output and consumption responses
       IMPL_SPECT_40_p(1,i) = real(svmaspect(0,smimp1(:,1),40));
       IMPL_SPECT_12_p(1,i) = real(svmaspect(0,smimp1(:,1),12));
       IMPL_SPECT_20_p(1,i) = real(svmaspect(0,smimp1(:,1),20));
     
         for j = 2:314;
          omega = j/100;
           IMPL_SPECT_40_p(j,i) = real(svmaspect(omega,smimp1(:,1),40));
           IMPL_SPECT_12_p(j,i) = real(svmaspect(omega,smimp1(:,1),12));
           IMPL_SPECT_20_p(j,i) = real(svmaspect(omega,smimp1(:,1),20));
         end; 
  
       IMPL_SPECT_40_t(1,i) = real(svmaspect(0,smimp1(:,2),40));
       IMPL_SPECT_12_t(1,i) = real(svmaspect(0,smimp1(:,2),12));
       IMPL_SPECT_20_t(1,i) = real(svmaspect(0,smimp1(:,2),20));
       %real(svmaspect(0,smimp1(:,2),20));
         for j = 2:314;
          omega = j/100;
           IMPL_SPECT_40_t(j,i) = real(svmaspect(omega,smimp1(:,2),40));
           IMPL_SPECT_12_t(j,i) = real(svmaspect(omega,smimp1(:,2),12));
           IMPL_SPECT_20_t(j,i) = real(svmaspect(omega,smimp1(:,2),20));
         end;   
         
       % Inflation rate responses  
       IMPL_SPECT_INF_40_p(1,i) = real(svmaspect(0,smimp2(:,1),40));
      
     
         for j = 2:314;
          omega = j/100;
           IMPL_SPECT_INF_40_p(j,i) = real(svmaspect(omega,smimp2(:,1),40));
         end; 
  
       IMPL_SPECT_INF_40_t(1,i) = real(svmaspect(0,smimp2(:,2),40));
       
       %real(svmaspect(0,smimp1(:,2),20));
         for j = 2:314;
          omega = j/100;
           IMPL_SPECT_INF_40_t(j,i) = real(svmaspect(omega,smimp2(:,2),40));
      
         end;   
 end;
   
    
end;

IMPL_SPECT_40_p = IMPL_SPECT_40_p(:,1:5000);
IMPL_SPECT_40_t = IMPL_SPECT_40_t(:,1:5000);

IMPL_SPECT_20_p = IMPL_SPECT_20_p(:,1:5000);
IMPL_SPECT_20_t = IMPL_SPECT_20_t(:,1:5000);

% Posterior mean
 mean_40_p = mean(IMPL_SPECT_40_p')';
 mean_40_t = mean(IMPL_SPECT_40_t')';
 mean_20_p = mean(IMPL_SPECT_20_p')';
 mean_20_t = mean(IMPL_SPECT_20_t')';
 
 mean_INF_40_p = mean(IMPL_SPECT_INF_40_p')';
 mean_INF_40_t = mean(IMPL_SPECT_INF_40_t')';


     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag)  '\impl_spect_40_p.mat'];
     save(savefile,'IMPL_SPECT_40_p','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag)  '\impl_spect_40_t.mat'];
     save(savefile,'IMPL_SPECT_40_t','-ascii'); 
     
     
  %    savefile = [mainpath '\info' num2str(infospec) '\impl_spect_INF_40_p.mat'];
  %   save(savefile,'IMPL_SPECT_INF_40_p','-ascii'); 
     
  %    savefile = [mainpath '\info' num2str(infospec) '\impl_spect_INF_40_t.mat'];
  %   save(savefile,'IMPL_SPECT_INF_40_t','-ascii'); 
     
     
  if varlag == 2;
  
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_40_p_mean_lag2.mat'];
     save(savefile,'mean_40_p','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag)  '\impl_spect_40_t_mean_lag2.mat'];
     save(savefile,'mean_40_t','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_20_p_mean_lag2.mat'];
     save(savefile,'mean_20_p','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_20_t_mean_lag2.mat'];
     save(savefile,'mean_20_t','-ascii'); 
     
  elseif varlag == 4;
      
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_40_p_mean_lag4.mat'];
     save(savefile,'mean_40_p','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag)  '\impl_spect_40_t_mean_lag4.mat'];
     save(savefile,'mean_40_t','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_20_p_mean_lag4.mat'];
     save(savefile,'mean_20_p','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_20_t_mean_lag4.mat'];
     save(savefile,'mean_20_t','-ascii'); 
     
  end
     
  
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_INF_40_p_mean.mat'];
     save(savefile,'mean_INF_40_p','-ascii'); 
     
     
     savefile = [mainpath '\info' num2str(infospec) '\VAR' num2str(varlag) '\impl_spect_INF_40_t_mean.mat'];
     save(savefile,'mean_INF_40_t','-ascii'); 
     
     